<?php

use Anomaly\CartsModule\Cart\CartModel;
use Anomaly\CartsModule\Item\ItemModel;
use Anomaly\Streams\Platform\Database\Migration\Migration;
use Anomaly\UsersModule\User\UserModel;

/**
 * Class AnomalyModuleCartCreateCartFields
 *
 * @link          http://pyrocms.com/
 * @author        PyroCMS, Inc. <support@pyrocms.com>
 * @author        Ryan Thompson <ryan@pyrocms.com>
 */
class AnomalyModuleCartsCreateCartsFields extends Migration
{

    /**
     * The addon fields.
     *
     * @var array
     */
    protected $fields = [
        'str_id'        => 'anomaly.field_type.text',
        'sku'           => 'anomaly.field_type.text',
        'name'          => 'anomaly.field_type.text',
        'price'         => 'anomaly.field_type.decimal',
        'total'         => 'anomaly.field_type.decimal',
        'tax'           => 'anomaly.field_type.decimal',
        'shipping'      => 'anomaly.field_type.decimal',
        'subtotal'      => 'anomaly.field_type.decimal',
        'discounts'     => 'anomaly.field_type.decimal',
        'instance'      => [
            'type'   => 'anomaly.field_type.slug',
            'config' => [
                'default_value' => 'default',
            ],
        ],
        'ip_address'    => 'anomaly.field_type.text',
        'quantity'      => [
            'type'   => 'anomaly.field_type.integer',
            'config' => [
                'min' => 1,
            ],
        ],
        'cart'          => [
            'type'   => 'anomaly.field_type.relationship',
            'config' => [
                'related' => CartModel::class,
            ],
        ],
        'item'          => [
            'type'   => 'anomaly.field_type.relationship',
            'config' => [
                'related' => ItemModel::class,
            ],
        ],
        'discount_code' => 'anomaly.field_type.polymorphic',
        'user'          => [
            'type'   => 'anomaly.field_type.relationship',
            'config' => [
                'related' => UserModel::class,
            ],
        ],
        'type'          => 'anomaly.field_type.slug',
        'value'         => 'anomaly.field_type.text',
        'options'       => 'anomaly.field_type.textarea',
        'entry'         => 'anomaly.field_type.polymorphic',

        'first_name' => 'anomaly.field_type.text',
        'last_name'  => 'anomaly.field_type.text',
        'email'      => 'anomaly.field_type.email',
        'company'    => 'anomaly.field_type.text',
        'phone'      => 'anomaly.field_type.text',

        'street_address' => 'anomaly.field_type.text',
        'city'           => 'anomaly.field_type.text',
        'postal_code'    => 'anomaly.field_type.text',
        'country'        => 'anomaly.field_type.country',
        'state'          => 'anomaly.field_type.state',

        'shipping_first_name'     => 'anomaly.field_type.text',
        'shipping_last_name'      => 'anomaly.field_type.text',
        'shipping_company'        => 'anomaly.field_type.text',
        'shipping_street_address' => 'anomaly.field_type.text',
        'shipping_city'           => 'anomaly.field_type.text',
        'shipping_postal_code'    => 'anomaly.field_type.text',
        'shipping_country'        => 'anomaly.field_type.country',
        'shipping_state'          => 'anomaly.field_type.state',
    ];

}
