<?php

use Anomaly\Streams\Platform\Database\Migration\Migration;

/**
 * Class AnomalyModuleCartsCreateCartsStream
 *
 * @link          http://pyrocms.com/
 * @author        PyroCMS, Inc. <support@pyrocms.com>
 * @author        Ryan Thompson <ryan@pyrocms.com>
 */
class AnomalyModuleCartsCreateCartsStream extends Migration
{

    /**
     * The stream definition.
     *
     * @var array
     */
    protected $stream = [
        'slug'      => 'carts',
        'trashable' => true,
    ];

    /**
     * The stream assignments.
     *
     * @var array
     */
    protected $assignments = [
        'str_id'     => [
            'required' => true,
            'unique'   => true,
        ],
        'instance'   => [
            'required' => true,
        ],
        'ip_address' => [
            'required' => true,
        ],
        'subtotal'   => [
            'required' => true,
        ],
        'tax'        => [
            'required' => true,
        ],
        'shipping'   => [
            'required' => true,
        ],
        'discounts'  => [
            'required' => true,
        ],
        'total'      => [
            'required' => true,
        ],
        'quantity'   => [
            'required' => true,
        ],
        'user',

        'first_name',
        'last_name',
        'email',

        'company',
        'phone',

        'street_address',
        'city',
        'postal_code',
        'country',
        'state',

        'shipping_first_name',
        'shipping_last_name',
        'shipping_company',
        'shipping_street_address',
        'shipping_city',
        'shipping_postal_code',
        'shipping_country',
        'shipping_state',
    ];

}
